﻿#region File Description
//-----------------------------------------------------------------------------
// Pyramid.cs
//
//-----------------------------------------------------------------------------
#endregion

#region Using Statements
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace Primitives3D
{
    /// <summary>
    /// Geometric primitive class for drawing cubes.
    /// </summary>
    public class PyramidPrimitive : GeometricPrimitive
    {
        /// <summary>
        /// Constructs a new cube primitive, using default settings.
        /// </summary>
        public PyramidPrimitive(GraphicsDevice graphicsDevice)
            : this(graphicsDevice, 1)
        {
        }


        /// <summary>
        /// Constructs a new cube primitive, with the specified size.
        /// </summary>
        public PyramidPrimitive(GraphicsDevice graphicsDevice, float size)
        {
            // pyramid 
            Vector3[] vertices =
            {
                new Vector3(0.0f, 0.5f, 0.0f), 
                new Vector3(0.5f, -0.5f, 0.5f), 
                new Vector3(-0.5f, -0.5f, 0.5f), 
                new Vector3(-0.5f, -0.5f, -0.5f),
                new Vector3(0.5f, -0.5f, -0.5f)
            };

            // Create each face in turn.
            foreach (Vector3 vertex in vertices)
            {
                AddVertex(vertex, vertex);
            }

            //파리미드의 옆면
            AddIndex(0);
            AddIndex(1);
            AddIndex(2);
            
            AddIndex(0);
            AddIndex(2);
            AddIndex(3);
            
            AddIndex(0);
            AddIndex(3);
            AddIndex(4);
            
            AddIndex(0);
            AddIndex(4);
            AddIndex(1);
            
            //피라미드의 바닥
            AddIndex(1);
            AddIndex(4);
            AddIndex(2);
            
            AddIndex(2);
            AddIndex(4);
            AddIndex(3);
           
            InitializePrimitive(graphicsDevice);
        }
    }
}
